"use strict";
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, privateMap) {
    if (!privateMap.has(receiver)) {
        throw new TypeError("attempted to get private field on non-instance");
    }
    return privateMap.get(receiver);
};
var _totalBytesSent, _totalBytesReceived;
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("./interfaces/core");
class NodeStats {
    constructor() {
        _totalBytesSent.set(this, {
            total: core_1.byteCount(0),
            multicastUdp: core_1.byteCount(0),
            udp: core_1.byteCount(0),
            http: core_1.byteCount(0),
            webSocket: core_1.byteCount(0)
        });
        _totalBytesReceived.set(this, {
            total: core_1.byteCount(0),
            multicastUdp: core_1.byteCount(0),
            udp: core_1.byteCount(0),
            http: core_1.byteCount(0),
            webSocket: core_1.byteCount(0)
        });
    }
    totalBytesSent() {
        return { ...__classPrivateFieldGet(this, _totalBytesSent) };
    }
    totalBytesReceived() {
        return { ...__classPrivateFieldGet(this, _totalBytesReceived) };
    }
    reportBytesSent(method, toNodeId, numBytes) {
        __classPrivateFieldGet(this, _totalBytesSent)[method] = core_1.addByteCount(__classPrivateFieldGet(this, _totalBytesSent)[method], numBytes);
        __classPrivateFieldGet(this, _totalBytesSent)['total'] = core_1.addByteCount(__classPrivateFieldGet(this, _totalBytesSent)['total'], numBytes);
    }
    reportBytesReceived(method, fromNodeId, numBytes) {
        __classPrivateFieldGet(this, _totalBytesReceived)[method] = core_1.addByteCount(__classPrivateFieldGet(this, _totalBytesReceived)[method], numBytes);
        __classPrivateFieldGet(this, _totalBytesReceived)['total'] = core_1.addByteCount(__classPrivateFieldGet(this, _totalBytesReceived)['total'], numBytes);
    }
}
exports.default = NodeStats;
_totalBytesSent = new WeakMap(), _totalBytesReceived = new WeakMap();
//# sourceMappingURL=NodeStats.js.map