"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.action = void 0;
const _globalData = {
    verbose: 0
};
const action = async (actionName, actionData, operation, onError) => {
    try {
        if (_globalData.verbose > 0) {
            /* istanbul ignore next */
            console.info(`${actionName}`);
        }
        await operation();
    }
    catch (err) {
        /* istanbul ignore next */
        if (onError) {
            await onError(err);
        }
        else {
            /* istanbul ignore next */
            console.warn(`@@@@@@@@@@@@@@@@@@ Error in ${actionName}: ${err.message}`);
        }
    }
};
exports.action = action;
//# sourceMappingURL=action.js.map