"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, privateMap, value) {
    if (!privateMap.has(receiver)) {
        throw new TypeError("attempted to set private field on non-instance");
    }
    privateMap.set(receiver, value);
    return value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, privateMap) {
    if (!privateMap.has(receiver)) {
        throw new TypeError("attempted to get private field on non-instance");
    }
    return privateMap.get(receiver);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _nodeId, _rateEstimator;
Object.defineProperty(exports, "__esModule", { value: true });
const RateEstimator_1 = __importDefault(require("./RateEstimator"));
class DownloadOptimizerProviderNode {
    constructor(nodeId) {
        _nodeId.set(this, void 0);
        _rateEstimator.set(this, new RateEstimator_1.default());
        this.reportStart = () => {
            __classPrivateFieldGet(this, _rateEstimator).reportStart();
        };
        this.reportStop = () => {
            __classPrivateFieldGet(this, _rateEstimator).reportStop();
        };
        this.reportBytes = (n) => {
            __classPrivateFieldGet(this, _rateEstimator).reportBytes(n);
        };
        __classPrivateFieldSet(this, _nodeId, nodeId);
    }
    nodeId() {
        return __classPrivateFieldGet(this, _nodeId);
    }
    estimatedRateBps() {
        return __classPrivateFieldGet(this, _rateEstimator).estimatedRateBps();
    }
    isDownloading() {
        return __classPrivateFieldGet(this, _rateEstimator).isRunning();
    }
}
_nodeId = new WeakMap(), _rateEstimator = new WeakMap();
exports.default = DownloadOptimizerProviderNode;
//# sourceMappingURL=DownloadOptimizerProviderNode.js.map