"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const mockDgramCreateSocket_1 = __importDefault(require("./mockDgramCreateSocket"));
const MockKacheryStorageManager_1 = __importDefault(require("./MockKacheryStorageManager"));
const MockLocalFeedManager_1 = __importDefault(require("./MockLocalFeedManager"));
const MockWebSocket_1 = require("./MockWebSocket");
const mockStartHttpServer = async (app, listenPort) => {
    throw Error('Unable to start http server in mock mode');
};
const mockExternalInterface = (daemonGroup, getDefects) => {
    const httpPostJson = (address, path, data, opts) => {
        return daemonGroup.mockHttpPostJson(address, path, data, opts);
    };
    const httpGetDownload = (address, path, stats, opts) => {
        return daemonGroup.mockHttpGetDownload(address, path, stats, opts);
    };
    const createLocalFeedManager = (mutableManager) => {
        return new MockLocalFeedManager_1.default();
    };
    const createKacheryStorageManager = () => {
        return new MockKacheryStorageManager_1.default(getDefects);
    };
    const dgramCreateSocket = (args) => {
        if (getDefects().createUdpSocketDefect) {
            throw Error('Intentional error creating socket due to defect');
        }
        return mockDgramCreateSocket_1.default(args);
    };
    return {
        httpPostJson,
        httpGetDownload,
        dgramCreateSocket,
        startWebSocketServer: MockWebSocket_1.mockStartWebSocketServer,
        createWebSocket: MockWebSocket_1.mockCreateWebSocket,
        createKacheryStorageManager,
        createLocalFeedManager,
        startHttpServer: mockStartHttpServer,
        isMock: true
    };
};
exports.default = mockExternalInterface;
//# sourceMappingURL=mockExternalInterface.js.map