"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const dgram_1 = __importDefault(require("dgram"));
const httpRequests_1 = require("./httpRequests");
const KacheryStorageManager_1 = require("./kacheryStorage/KacheryStorageManager");
const LocalFeedManager_1 = __importDefault(require("./LocalFeedManager"));
const startHttpServer_1 = __importDefault(require("./startHttpServer"));
const webSocket_1 = require("./webSocket");
const realExternalInterface = (storageDir, configDir) => {
    const dgramCreateSocket = (args) => {
        return dgram_1.default.createSocket({ type: args.type, reuseAddr: args.reuseAddr });
    };
    const createKacheryStorageManager = () => {
        return new KacheryStorageManager_1.KacheryStorageManager(storageDir);
    };
    const createLocalFeedManager = (mutableManager) => {
        return new LocalFeedManager_1.default(storageDir, mutableManager, configDir);
    };
    return {
        httpPostJson: httpRequests_1.httpPostJson,
        httpGetDownload: httpRequests_1.httpGetDownload,
        dgramCreateSocket,
        startWebSocketServer: webSocket_1.startWebSocketServer,
        createWebSocket: webSocket_1.createWebSocket,
        createKacheryStorageManager,
        createLocalFeedManager,
        startHttpServer: startHttpServer_1.default,
        isMock: false
    };
};
exports.default = realExternalInterface;
//# sourceMappingURL=realExternalInterface.js.map