"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class DownloadFileDataMethodOptimizer {
    constructor(node, remoteNode) {
        this.node = node;
        this.remoteNode = remoteNode;
    }
    determineDownloadFileDataMethod(method) {
        const availableMethods = {
            'udp': ((this.node.publicUdpSocketServer()) && (this.remoteNode.getUdpAddressForRemoteNode())) ? true : false,
            'http': this.remoteNode.getRemoteNodeHttpAddress() ? true : false,
            'http-proxy': this.remoteNode.getRemoteNodeDataProxyNode() ? true : false
        };
        if (method === 'default') {
            if (availableMethods['http']) {
                return 'http';
            }
            else if (availableMethods['udp']) {
                return 'udp';
            }
            else if (availableMethods['http-proxy']) {
                return 'http-proxy';
            }
            else {
                return null;
            }
        }
        else {
            return availableMethods[method] ? method : null;
        }
    }
}
exports.default = DownloadFileDataMethodOptimizer;
//# sourceMappingURL=DownloadFileDataMethodOptimizer.js.map