"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.handleReportNewSubfeedMessages = void 0;
const core_1 = require("../interfaces/core");
const handleReportNewSubfeedMessages = async (node, fromNodeId, requestData) => {
    const { feedId, subfeedHash, numMessages } = requestData;
    try {
        // CHAIN:get_remote_messages:step(15)
        await node.feedManager().reportNumRemoteMessages(fromNodeId, feedId, subfeedHash, numMessages);
        return {
            requestType: 'reportNewSubfeedMessages',
            success: true,
            errorMessage: null
        };
    }
    catch (err) {
        return {
            requestType: 'reportNewSubfeedMessages',
            success: false,
            errorMessage: core_1.errorMessage(`Error reporting subfeed messages: ${err.message}`)
        };
    }
};
exports.handleReportNewSubfeedMessages = handleReportNewSubfeedMessages;
//# sourceMappingURL=handleReportSubfeedMessages.js.map