"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, privateMap, value) {
    if (!privateMap.has(receiver)) {
        throw new TypeError("attempted to set private field on non-instance");
    }
    privateMap.set(receiver, value);
    return value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, privateMap) {
    if (!privateMap.has(receiver)) {
        throw new TypeError("attempted to get private field on non-instance");
    }
    return privateMap.get(receiver);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _node, _app, _server, _simpleGetHandlers, _simplePostHandlers;
Object.defineProperty(exports, "__esModule", { value: true });
exports.isFeedApiSetAccessRulesResponse = exports.isFeedApiSetAccessRulesRequest = exports.isFeedApiGetAccessRulesResponse = exports.isFeedApiGetAccessRulesRequest = exports.isFeedApiGetFeedIdResponse = exports.isFeedApiGetFeedIdRequest = exports.isFeedApiDeleteFeedResponse = exports.isFeedApiDeleteFeedRequest = exports.isFeedApiGetFeedInfoResponse = exports.isFeedApiGetFeedInfoRequest = exports.isFeedApiGetNumLocalMessagesResponse = exports.isFeedApiGetNumLocalMessagesRequest = exports.isFeedApiSubmitMessageResponse = exports.isFeedApiSubmitMessageRequest = exports.isFeedApiAppendMessagesResponse = exports.isFeedApiAppendMessagesRequest = exports.isFeedApiCreateFeedResponse = exports.isFeedApiCreateFeedRequest = exports.isFeedApiGetSignedMessagesResponse = exports.isFeedApiGetSignedMessagesRequest = exports.isFeedApiGetMessagesResponse = exports.isFeedApiGetMessagesRequest = exports.isMutableApiDeleteResponse = exports.isMutableApiDeleteRequest = exports.isMutableApiGetResponse = exports.isMutableApiGetRequest = exports.isMutableApiSetResponse = exports.isMutableApiSetRequest = exports.isFeedApiWatchForNewMessagesResponse = exports.isFeedApiWatchForNewMessagesRequest = exports.isDaemonApiProbeResponse = exports.isDaemonApiProbeResponseJoinedChannels = void 0;
const express_1 = __importDefault(require("express"));
const json_socket_1 = __importDefault(require("json-socket"));
const cli_1 = require("../cli");
const action_1 = require("../common/action");
const DataStreamy_1 = __importDefault(require("../common/DataStreamy"));
const util_1 = require("../common/util");
const getStats_1 = require("../getStats");
const core_1 = require("../interfaces/core");
const loadFile_1 = require("../loadFile");
const protocolVersion_1 = require("../protocolVersion");
const ConfigUpdateService_1 = require("./ConfigUpdateService");
;
const isDaemonApiProbeResponseJoinedChannels = (x) => {
    return core_1._validateObject(x, {
        channelConfig: cli_1.isChannelConfig,
        channelConfigUrl: core_1.isChannelConfigUrl
    });
};
exports.isDaemonApiProbeResponseJoinedChannels = isDaemonApiProbeResponseJoinedChannels;
const isDaemonApiProbeResponse = (x) => {
    return core_1._validateObject(x, {
        success: core_1.isBoolean,
        protocolVersion: core_1.isEqualTo(protocolVersion_1.protocolVersion()),
        daemonVersion: core_1.isDaemonVersion,
        nodeId: core_1.isNodeId,
        isBootstrapNode: core_1.isBoolean,
        webSocketAddress: core_1.isOneOf([core_1.isNull, core_1.isAddress]),
        publicUdpSocketAddress: core_1.isOneOf([core_1.isNull, core_1.isAddress]),
        joinedChannels: core_1.isArrayOf(ConfigUpdateService_1.isJoinedChannelConfig),
        kacheryStorageDir: core_1.isOneOf([core_1.isNull, core_1.isString])
    });
};
exports.isDaemonApiProbeResponse = isDaemonApiProbeResponse;
const isStoreFileRequestData = (x) => {
    return core_1._validateObject(x, {
        localFilePath: core_1.isString
    });
};
const isApiFindFileRequest = (x) => {
    return core_1._validateObject(x, {
        fileKey: core_1.isFileKey,
        timeoutMsec: core_1.isDurationMsec
    });
};
const isApiLoadFileRequest = (x) => {
    return core_1._validateObject(x, {
        fileKey: core_1.isFileKey,
        fromNode: core_1.isOneOf([core_1.isNull, core_1.isNodeId])
    });
};
const isFeedApiWatchForNewMessagesRequest = (x) => {
    return core_1._validateObject(x, {
        subfeedWatches: core_1.isSubfeedWatches,
        waitMsec: core_1.isDurationMsec,
        signed: core_1.optional(core_1.isBoolean),
        maxNumMessages: core_1.optional(core_1.isMessageCount)
    });
};
exports.isFeedApiWatchForNewMessagesRequest = isFeedApiWatchForNewMessagesRequest;
const isFeedApiWatchForNewMessagesResponse = (x) => {
    return core_1._validateObject(x, {
        success: core_1.isBoolean,
        messages: core_1.isOneOf([core_1.isObjectOf(core_1.isString, core_1.isArrayOf(core_1.isSubfeedMessage)), core_1.isObjectOf(core_1.isString, core_1.isArrayOf(core_1.isSignedSubfeedMessage))])
    });
};
exports.isFeedApiWatchForNewMessagesResponse = isFeedApiWatchForNewMessagesResponse;
const isMutableApiSetRequest = (x) => {
    return core_1._validateObject(x, {
        key: core_1.isJSONValue,
        value: core_1.isJSONValue
    });
};
exports.isMutableApiSetRequest = isMutableApiSetRequest;
const isMutableApiSetResponse = (x) => {
    return core_1._validateObject(x, {
        success: core_1.isBoolean
    });
};
exports.isMutableApiSetResponse = isMutableApiSetResponse;
const isMutableApiGetRequest = (x) => {
    return core_1._validateObject(x, {
        key: core_1.isJSONValue
    });
};
exports.isMutableApiGetRequest = isMutableApiGetRequest;
const isMutableApiGetResponse = (x) => {
    return core_1._validateObject(x, {
        success: core_1.isBoolean,
        found: core_1.isBoolean,
        value: core_1.isJSONValue
    });
};
exports.isMutableApiGetResponse = isMutableApiGetResponse;
const isMutableApiDeleteRequest = (x) => {
    return core_1._validateObject(x, {
        key: core_1.isJSONValue
    });
};
exports.isMutableApiDeleteRequest = isMutableApiDeleteRequest;
const isMutableApiDeleteResponse = (x) => {
    return core_1._validateObject(x, {
        success: core_1.isBoolean
    });
};
exports.isMutableApiDeleteResponse = isMutableApiDeleteResponse;
const isFeedApiGetMessagesRequest = (x) => {
    return core_1._validateObject(x, {
        feedId: core_1.isFeedId,
        subfeedHash: core_1.isSubfeedHash,
        position: core_1.isSubfeedPosition,
        maxNumMessages: core_1.isMessageCount,
        waitMsec: core_1.isDurationMsec,
    });
};
exports.isFeedApiGetMessagesRequest = isFeedApiGetMessagesRequest;
const isFeedApiGetMessagesResponse = (x) => {
    return core_1._validateObject(x, {
        success: core_1.isBoolean,
        messages: core_1.isArrayOf(core_1.isSubfeedMessage)
    });
};
exports.isFeedApiGetMessagesResponse = isFeedApiGetMessagesResponse;
const isFeedApiGetSignedMessagesRequest = (x) => {
    return core_1._validateObject(x, {
        feedId: core_1.isFeedId,
        subfeedHash: core_1.isSubfeedHash,
        position: core_1.isSubfeedPosition,
        maxNumMessages: core_1.isMessageCount,
        waitMsec: core_1.isDurationMsec,
    });
};
exports.isFeedApiGetSignedMessagesRequest = isFeedApiGetSignedMessagesRequest;
const isFeedApiGetSignedMessagesResponse = (x) => {
    return core_1._validateObject(x, {
        success: core_1.isBoolean,
        signedMessages: core_1.isArrayOf(core_1.isSignedSubfeedMessage)
    });
};
exports.isFeedApiGetSignedMessagesResponse = isFeedApiGetSignedMessagesResponse;
const isFeedApiCreateFeedRequest = (x) => {
    return core_1._validateObject(x, {
        feedName: core_1.optional(core_1.isFeedName)
    });
};
exports.isFeedApiCreateFeedRequest = isFeedApiCreateFeedRequest;
const isFeedApiCreateFeedResponse = (x) => {
    return core_1._validateObject(x, {
        success: core_1.isBoolean,
        feedId: core_1.isFeedId
    });
};
exports.isFeedApiCreateFeedResponse = isFeedApiCreateFeedResponse;
const isFeedApiAppendMessagesRequest = (x) => {
    return core_1._validateObject(x, {
        feedId: core_1.isFeedId,
        subfeedHash: core_1.isSubfeedHash,
        messages: core_1.isArrayOf(core_1.isSubfeedMessage)
    });
};
exports.isFeedApiAppendMessagesRequest = isFeedApiAppendMessagesRequest;
const isFeedApiAppendMessagesResponse = (x) => {
    return core_1._validateObject(x, {
        success: core_1.isBoolean
    });
};
exports.isFeedApiAppendMessagesResponse = isFeedApiAppendMessagesResponse;
const isFeedApiSubmitMessageRequest = (x) => {
    return core_1._validateObject(x, {
        feedId: core_1.isFeedId,
        subfeedHash: core_1.isSubfeedHash,
        message: core_1.isSubmittedSubfeedMessage,
        timeoutMsec: core_1.isDurationMsec
    });
};
exports.isFeedApiSubmitMessageRequest = isFeedApiSubmitMessageRequest;
const isFeedApiSubmitMessageResponse = (x) => {
    return core_1._validateObject(x, {
        success: core_1.isBoolean
    });
};
exports.isFeedApiSubmitMessageResponse = isFeedApiSubmitMessageResponse;
const isFeedApiGetNumLocalMessagesRequest = (x) => {
    return core_1._validateObject(x, {
        feedId: core_1.isFeedId,
        subfeedHash: core_1.isSubfeedHash
    });
};
exports.isFeedApiGetNumLocalMessagesRequest = isFeedApiGetNumLocalMessagesRequest;
const isFeedApiGetNumLocalMessagesResponse = (x) => {
    return core_1._validateObject(x, {
        success: core_1.isBoolean,
        numMessages: core_1.isMessageCount
    });
};
exports.isFeedApiGetNumLocalMessagesResponse = isFeedApiGetNumLocalMessagesResponse;
const isFeedApiGetFeedInfoRequest = (x) => {
    return core_1._validateObject(x, {
        feedId: core_1.isFeedId,
        timeoutMsec: core_1.isDurationMsec
    });
};
exports.isFeedApiGetFeedInfoRequest = isFeedApiGetFeedInfoRequest;
const isFeedApiGetFeedInfoResponse = (x) => {
    return core_1._validateObject(x, {
        success: core_1.isBoolean,
        isWriteable: core_1.isBoolean,
        nodeId: core_1.isNodeId
    });
};
exports.isFeedApiGetFeedInfoResponse = isFeedApiGetFeedInfoResponse;
const isFeedApiDeleteFeedRequest = (x) => {
    return core_1._validateObject(x, {
        feedId: core_1.isFeedId
    });
};
exports.isFeedApiDeleteFeedRequest = isFeedApiDeleteFeedRequest;
const isFeedApiDeleteFeedResponse = (x) => {
    return core_1._validateObject(x, {
        success: core_1.isBoolean
    });
};
exports.isFeedApiDeleteFeedResponse = isFeedApiDeleteFeedResponse;
const isFeedApiGetFeedIdRequest = (x) => {
    return core_1._validateObject(x, {
        feedName: core_1.isFeedName
    });
};
exports.isFeedApiGetFeedIdRequest = isFeedApiGetFeedIdRequest;
const isFeedApiGetFeedIdResponse = (x) => {
    return core_1._validateObject(x, {
        success: core_1.isBoolean,
        feedId: core_1.isOneOf([core_1.isNull, core_1.isFeedId])
    });
};
exports.isFeedApiGetFeedIdResponse = isFeedApiGetFeedIdResponse;
const isFeedApiGetAccessRulesRequest = (x) => {
    return core_1._validateObject(x, {
        feedId: core_1.isFeedId,
        subfeedHash: core_1.isSubfeedHash
    });
};
exports.isFeedApiGetAccessRulesRequest = isFeedApiGetAccessRulesRequest;
const isFeedApiGetAccessRulesResponse = (x) => {
    return core_1._validateObject(x, {
        success: core_1.isBoolean,
        accessRules: core_1.isOneOf([core_1.isNull, core_1.isSubfeedAccessRules])
    });
};
exports.isFeedApiGetAccessRulesResponse = isFeedApiGetAccessRulesResponse;
const isFeedApiSetAccessRulesRequest = (x) => {
    return core_1._validateObject(x, {
        feedId: core_1.isFeedId,
        subfeedHash: core_1.isSubfeedHash,
        accessRules: core_1.isSubfeedAccessRules
    });
};
exports.isFeedApiSetAccessRulesRequest = isFeedApiSetAccessRulesRequest;
const isFeedApiSetAccessRulesResponse = (x) => {
    return core_1._validateObject(x, {
        success: core_1.isBoolean
    });
};
exports.isFeedApiSetAccessRulesResponse = isFeedApiSetAccessRulesResponse;
class DaemonApiServer {
    // This is the API server for the local daemon
    // The local Python code communicates with the daemon
    // via this API
    constructor(node, opts) {
        _node.set(this, void 0);
        _app.set(this, void 0);
        // #server: http.Server | https.Server | null = null
        _server.set(this, null);
        _simpleGetHandlers.set(this, [
            {
                // /probe - check whether the daemon is up and running and return info such as the node ID
                path: '/probe',
                handler: async (query) => {
                    /* istanbul ignore next */
                    return await this._handleProbe();
                }
            },
            {
                // /halt - halt the kachery-p2p daemon (stops the server process)
                path: '/halt',
                handler: async (query) => {
                    /* istanbul ignore next */
                    return await this._handleHalt();
                }
            },
            {
                path: '/stats',
                handler: async (query) => {
                    return await this._handleStats(query);
                }
            }
        ]);
        _simplePostHandlers.set(this, [
            {
                // /probe - check whether the daemon is up and running and return info such as the node ID
                path: '/probe',
                handler: async (reqData) => {
                    /* istanbul ignore next */
                    return await this._handleProbe();
                }
            },
            {
                // /storeFile - Store a local file in local kachery storage
                path: '/storeFile',
                handler: async (reqData) => {
                    /* istanbul ignore next */
                    return await this._handleStoreFile(reqData);
                }
            },
            {
                // /feed/createFeed - create a new writeable feed on this node
                path: '/feed/createFeed',
                handler: async (reqData) => { return await this._handleFeedApiCreateFeed(reqData); }
            },
            {
                // /feed/deleteFeed - delete feed on this node
                path: '/feed/deleteFeed',
                handler: async (reqData) => { return await this._handleFeedApiDeleteFeed(reqData); }
            },
            {
                // /feed/getFeedId - lookup the ID of a local feed based on its name
                path: '/feed/getFeedId',
                handler: async (reqData) => { return await this._handleFeedApiGetFeedId(reqData); }
            },
            {
                // /feed/appendMessages - append messages to a local writeable subfeed
                path: '/feed/appendMessages',
                handler: async (reqData) => { return await this._handleFeedApiAppendMessages(reqData); }
            },
            {
                // /feed/submitMessage - submit messages to a remote live subfeed (must have permission)
                path: '/feed/submitMessage',
                handler: async (reqData) => { return await this._handleFeedApiSubmitMessage(reqData); }
            },
            {
                // /feed/getNumLocalMessages - get number of messages in a subfeed
                path: '/feed/getNumLocalMessages',
                handler: async (reqData) => { return await this._handleFeedApiGetNumLocalMessages(reqData); }
            },
            {
                // /feed/getFeedInfo - get info for a feed - such as whether it is writeable
                path: '/feed/getFeedInfo',
                handler: async (reqData) => { return await this._handleFeedApiGetFeedInfo(reqData); }
            },
            {
                // /feed/getAccessRules - get access rules for a local writeable subfeed
                path: '/feed/getAccessRules',
                handler: async (reqData) => { return await this._handleFeedApiGetAccessRules(reqData); }
            },
            {
                // /feed/setAccessRules - set access rules for a local writeable subfeed
                path: '/feed/setAccessRules',
                handler: async (reqData) => { return await this._handleFeedApiSetAccessRules(reqData); }
            },
            {
                // /feed/watchForNewMessages - wait until new messages have been appended to a list of watched subfeeds
                path: '/feed/watchForNewMessages',
                handler: async (reqData) => { return await this._handleFeedApiWatchForNewMessages(reqData); }
            },
            {
                // /mutable/get - get a mutable value
                path: '/mutable/get',
                handler: async (reqData) => { return await this._handleMutableApiGet(reqData); }
            },
            {
                // /mutable/set - set a mutable value
                path: '/mutable/set',
                handler: async (reqData) => { return await this._handleMutableApiSet(reqData); }
            }
        ]
        // This is the API server for the local daemon
        // The local Python code communicates with the daemon
        // via this API
        );
        __classPrivateFieldSet(this, _node, node); // The kachery-p2p daemon
        __classPrivateFieldSet(// The kachery-p2p daemon
        this, _app, express_1.default()); // the express app
        __classPrivateFieldGet(this, _app).set('json spaces', 4); // when we respond with json, this is how it will be formatted
        // this.#app.use(cors()); // in the future, if we want to do this
        __classPrivateFieldGet(this, _app).use(express_1.default.json());
        __classPrivateFieldGet(this, _app).all('/*', (req, res, next) => {
            // if (!isLocalRequest(req)) {
            //     console.warn(`Rejecting access to remote request from ${req.socket.remoteAddress}`);
            //     res.status(403).send("API only accessible from the local device").end();
            //     return;
            // }
            if (req.path !== '/probe') {
                const authCode = req.header('KACHERY-CLIENT-AUTH-CODE');
                if (!authCode) {
                    res.status(403).send("Missing client auth code in daemon request. You probably need to upgrade kachery-p2p.").end();
                    return;
                }
                if (!__classPrivateFieldGet(this, _node).verifyClientAuthCode(authCode)) {
                    res.status(403).send("Incorrect client authorization code.").end();
                    return;
                }
            }
            /* istanbul ignore next */
            next();
        });
        __classPrivateFieldGet(this, _simpleGetHandlers).forEach(h => {
            __classPrivateFieldGet(this, _app).get(h.path, async (req, res) => {
                /////////////////////////////////////////////////////////////////////////
                /* istanbul ignore next */
                await action_1.action(h.path, { context: 'Daemon API' }, async () => {
                    const response = await h.handler(req.query);
                    if (response.format === 'html') {
                        res.end(response.html);
                    }
                    else {
                        res.json(response);
                    }
                }, async (err) => {
                    await this._errorResponse(req, res, 500, err.message);
                });
                /////////////////////////////////////////////////////////////////////////
            });
        });
        __classPrivateFieldGet(this, _simplePostHandlers).forEach(h => {
            __classPrivateFieldGet(this, _app).post(h.path, async (req, res) => {
                /////////////////////////////////////////////////////////////////////////
                /* istanbul ignore next */
                await action_1.action(h.path, { context: 'Daemon API' }, async () => {
                    const reqData = req.body;
                    if (!core_1.isJSONObject(reqData))
                        throw Error('Not a JSONObject');
                    const response = await h.handler(reqData);
                    res.json(response);
                }, async (err) => {
                    await this._errorResponse(req, res, 500, err.message);
                });
                /////////////////////////////////////////////////////////////////////////
            });
        });
        // /findFile - find a file (or feed) in the remote nodes. May return more than one.
        __classPrivateFieldGet(this, _app).post('/findFile', async (req, res) => {
            /////////////////////////////////////////////////////////////////////////
            /* istanbul ignore next */
            await action_1.action('/findFile', { context: 'Daemon API' }, async () => {
                await this._apiFindFile(req, res);
            }, async (err) => {
                await this._errorResponse(req, res, 500, err.message);
            });
            /////////////////////////////////////////////////////////////////////////
        });
        // /loadFile - download file from remote node(s) and store in kachery storage
        __classPrivateFieldGet(this, _app).post('/loadFile', async (req, res) => {
            /////////////////////////////////////////////////////////////////////////
            /* istanbul ignore next */
            await action_1.action('/loadFile', { context: 'Daemon API' }, async () => {
                await this._apiLoadFile(req, res);
            }, async (err) => {
                res.status(500).send('Error loading file.');
            });
            /////////////////////////////////////////////////////////////////////////
        });
        // /store - store a file by streaming data to the daemon
        __classPrivateFieldGet(this, _app).post('/store', async (req, res) => {
            /////////////////////////////////////////////////////////////////////////
            /* istanbul ignore next */
            await action_1.action('/store', { context: 'Daemon API' }, async () => {
                await this._apiStore(req, res);
            }, async (err) => {
                res.status(500).send('Error storing file from data stream.');
            });
            /////////////////////////////////////////////////////////////////////////
        });
    }
    stop() {
        /* istanbul ignore next */
        if (__classPrivateFieldGet(this, _server)) {
            __classPrivateFieldGet(this, _server).close();
        }
    }
    // async mockGetJson(path: string): Promise<JSONObject> {
    //     for (let h of this.#simpleGetHandlers) {
    //         if (h.path === path) {
    //             return await h.handler()
    //         }
    //     }
    //     throw Error(`Unexpected path in mockGetJson: ${path}`)
    // }
    async mockPostJson(path, data) {
        for (let h of __classPrivateFieldGet(this, _simplePostHandlers)) {
            if (h.path === path) {
                return await h.handler(data);
            }
        }
        /* istanbul ignore next */
        throw Error(`Unexpected path in mockPostJson: ${path}`);
    }
    async mockPostLoadFile(data) {
        /* istanbul ignore next */
        if (!isApiLoadFileRequest(data))
            throw Error('Unexpected data in mockPostLoadFile');
        return await this._loadFile(data);
    }
    async mockPostFindFile(reqData) {
        /* istanbul ignore next */
        if (!isApiFindFileRequest(reqData))
            throw Error('Unexpected data in mockPostFindFile');
        return await this._findFile(reqData);
    }
    // /probe - check whether the daemon is up and running and return info such as the node ID
    /* istanbul ignore next */
    async _handleProbe() {
        const joinedChannels = __classPrivateFieldGet(this, _node).joinedChannels();
        const response = {
            success: true,
            protocolVersion: protocolVersion_1.protocolVersion(),
            daemonVersion: protocolVersion_1.daemonVersion(),
            nodeId: __classPrivateFieldGet(this, _node).nodeId(),
            isBootstrapNode: __classPrivateFieldGet(this, _node).isBootstrapNode(),
            webSocketAddress: __classPrivateFieldGet(this, _node).webSocketAddress(),
            publicUdpSocketAddress: __classPrivateFieldGet(this, _node).publicUdpSocketAddress(),
            joinedChannels,
            kacheryStorageDir: __classPrivateFieldGet(this, _node).kacheryStorageManager().storageDir()
        };
        /* istanbul ignore next */
        if (!core_1.isJSONObject(response))
            throw Error('Unexpected, not a JSON-serializable object');
        return response;
    }
    // /storeFile - store local file in local kachery storage
    /* istanbul ignore next */
    async _handleStoreFile(reqData) {
        if (!isStoreFileRequestData(reqData))
            throw Error('Unexpected request data for storeFile.');
        const { sha1, manifestSha1 } = await __classPrivateFieldGet(this, _node).kacheryStorageManager().storeLocalFile(reqData.localFilePath);
        const response = {
            success: true,
            error: null,
            sha1,
            manifestSha1
        };
        /* istanbul ignore next */
        if (!core_1.isJSONObject(response))
            throw Error('Unexpected json object in _handleStoreFile');
        return response;
    }
    // /halt - halt the kachery-p2p daemon (stops the server process)
    /* istanbul ignore next */
    async _handleHalt() {
        ;
        this.stop();
        const response = { success: true };
        if (!core_1.isJSONObject(response))
            throw Error('Unexpected, not a JSON-serializable object');
        setTimeout(() => {
            process.exit();
        }, core_1.durationMsecToNumber(core_1.scaledDurationMsec(3000)));
        return response;
    }
    // /stats
    async _handleStats(query) {
        /* istanbul ignore next */
        if (!getStats_1.isGetStatsOpts(query))
            throw Error('Unexpected query.');
        const stats = __classPrivateFieldGet(this, _node).getStats(query);
        const response = {
            success: true,
            format: (query.format || 'json'),
            html: stats.html,
            stats
        };
        /* istanbul ignore next */
        if (!core_1.isJSONObject(response))
            throw Error('Unexpected json object in _handleStats');
        return response;
    }
    // /findFile - find a file (or feed) locally or in the remote nodes. May return more than one.
    /* istanbul ignore next */
    async _apiFindFile(req, res) {
        const reqData = req.body;
        /* istanbul ignore next */
        if (!isApiFindFileRequest(reqData))
            throw Error('Invalid request in _apiFindFile');
        const x = await this._findFile(reqData);
        const jsonSocket = new json_socket_1.default(res);
        let isDone = false;
        x.onFound((result) => {
            if (isDone)
                return;
            // may return more than one result
            // we send them one-by-one
            jsonSocket.sendMessage(result, () => { });
        });
        x.onFinished(() => {
            if (isDone)
                return;
            // we are done
            isDone = true;
            res.end();
        });
        req.on('close', () => {
            // if the request socket is closed, we cancel the find request
            isDone = true;
            x.cancel();
        });
    }
    async _findFile(reqData) {
        const { fileKey, timeoutMsec } = reqData;
        return __classPrivateFieldGet(this, _node).findFile({ fileKey, timeoutMsec });
    }
    // /loadFile - load a file from remote kachery node(s) and store in kachery storage
    /* istanbul ignore next */
    async _apiLoadFile(req, res) {
        const jsonSocket = new json_socket_1.default(res);
        let x;
        const apiLoadFileRequest = req.body;
        if (!isApiLoadFileRequest(apiLoadFileRequest)) {
            jsonSocket.sendMessage({ type: 'error', error: 'Invalid api load file request' }, () => { });
            res.end();
            return;
        }
        try {
            x = await this._loadFile(apiLoadFileRequest);
        }
        catch (err) {
            jsonSocket.sendMessage({ type: 'error', error: err.message }, () => { });
            res.end();
            return;
        }
        let isDone = false;
        x.onFinished(() => {
            if (isDone)
                return;
            // we are done
            const localFilePath = apiLoadFileRequest.fileKey.sha1;
            __classPrivateFieldGet(this, _node).kacheryStorageManager().findFile(apiLoadFileRequest.fileKey).then(({ found, size, localFilePath }) => {
                if (isDone)
                    return;
                if (found) {
                    if (localFilePath) {
                        isDone = true;
                        jsonSocket.sendMessage({ type: 'finished', localFilePath }, () => { });
                        res.end();
                    }
                    else {
                        isDone = true;
                        jsonSocket.sendMessage({ type: 'error', error: 'Unexpected: load completed, but localFilePath is null.' }, () => { });
                        res.end();
                    }
                }
                else {
                    isDone = true;
                    jsonSocket.sendMessage({ type: 'error', error: 'Unexpected: did not find file in local kachery storage even after load completed' }, () => { });
                    res.end();
                }
            });
        });
        x.onError((err) => {
            if (isDone)
                return;
            isDone = true;
            jsonSocket.sendMessage({ type: 'error', error: err.message }, () => { });
            res.end();
        });
        x.onProgress((prog) => {
            jsonSocket.sendMessage({
                type: 'progress',
                bytesLoaded: prog.bytesLoaded,
                bytesTotal: prog.bytesTotal
            }, () => { });
        });
        req.on('close', () => {
            // if the request socket is closed, we cancel the load request
            isDone = true;
            x.cancel();
        });
    }
    // /store - store file by streaming data to daemon
    /* istanbul ignore next */
    async _apiStore(req, res) {
        const contentLength = req.header("Content-Length");
        if (!contentLength) {
            res.status(403).send("Missing Content-Length in header").end();
            return;
        }
        const fileSize = parseInt(contentLength);
        const x = new DataStreamy_1.default();
        req.on('data', (chunk) => {
            x.producer().data(chunk);
        });
        req.on('end', () => {
            x.producer().end();
        });
        req.on('error', (err) => {
            x.producer().error(err);
        });
        let response;
        try {
            const { sha1, manifestSha1 } = await __classPrivateFieldGet(this, _node).kacheryStorageManager().storeFileFromStream(x, core_1.byteCount(fileSize));
            response = {
                success: true,
                error: null,
                sha1,
                manifestSha1
            };
        }
        catch (err) {
            response = {
                success: true,
                error: err.message,
                sha1: null,
                manifestSha1: null
            };
        }
        /* istanbul ignore next */
        if (!core_1.isJSONObject(response))
            throw Error('Unexpected json object in _handleStoreFile');
        res.json(response);
    }
    async _loadFile(reqData) {
        /* istanbul ignore next */
        if (!isApiLoadFileRequest(reqData))
            throw Error('Invalid request in _apiLoadFile');
        const { fileKey, fromNode } = reqData;
        if (fileKey.manifestSha1) {
            console.info(`Loading file: sha1://${fileKey.sha1}?manifest=${fileKey.manifestSha1}`);
        }
        else {
            console.info(`Loading file: sha1://${fileKey.sha1}`);
        }
        const x = await loadFile_1.loadFile(__classPrivateFieldGet(this, _node), fileKey, { fromNode, label: fileKey.sha1.toString().slice(0, 5) });
        return x;
    }
    // /feed/createFeed - create a new writeable feed on this node
    async _handleFeedApiCreateFeed(reqData) {
        /* istanbul ignore next */
        if (!exports.isFeedApiCreateFeedRequest(reqData))
            throw Error('Invalid request in _feedApiCreateFeed');
        const feedName = reqData.feedName || null;
        const feedId = await __classPrivateFieldGet(this, _node).feedManager().createFeed({ feedName });
        const response = { success: true, feedId };
        if (!core_1.isJSONObject(response))
            throw Error('Unexpected, not a JSON-serializable object');
        return response;
    }
    // /feed/deleteFeed - delete feed on this node
    async _handleFeedApiDeleteFeed(reqData) {
        /* istanbul ignore next */
        if (!exports.isFeedApiDeleteFeedRequest(reqData))
            throw Error('Invalid request in _feedApiDeleteFeed');
        const { feedId } = reqData;
        await __classPrivateFieldGet(this, _node).feedManager().deleteFeed({ feedId });
        const response = { success: true };
        if (!core_1.isJSONObject(response))
            throw Error('Unexpected, not a JSON-serializable object');
        return response;
    }
    // /feed/getFeedId - lookup the ID of a local feed based on its name
    async _handleFeedApiGetFeedId(reqData) {
        /* istanbul ignore next */
        if (!exports.isFeedApiGetFeedIdRequest(reqData))
            throw Error('Invalid request in _feedApiGetFeedId');
        const { feedName } = reqData;
        const feedId = await __classPrivateFieldGet(this, _node).feedManager().getFeedId({ feedName });
        let response;
        if (!feedId) {
            response = { success: false, feedId: null };
        }
        else {
            response = { success: true, feedId };
        }
        if (!core_1.isJSONObject(response))
            throw Error('Unexpected, not a JSON-serializable object');
        return response;
    }
    // /feed/appendMessages - append messages to a local writeable subfeed
    async _handleFeedApiAppendMessages(reqData) {
        /* istanbul ignore next */
        if (!exports.isFeedApiAppendMessagesRequest(reqData))
            throw Error('Invalid request in _feedApiAppendMessages');
        const { feedId, subfeedHash, messages } = reqData;
        // CHAIN:append_messages:step(2)
        await __classPrivateFieldGet(this, _node).feedManager().appendMessages({
            feedId, subfeedHash, messages
        });
        const response = { success: true };
        if (!core_1.isJSONObject(response))
            throw Error('Unexpected, not a JSON-serializable object');
        return response;
    }
    // /feed/submitMessage - submit message to a remote live subfeed (must have permission)
    async _handleFeedApiSubmitMessage(reqData) {
        /* istanbul ignore next */
        if (!exports.isFeedApiSubmitMessageRequest(reqData))
            throw Error('Invalid request in _feedApiSubmitMessage');
        const { feedId, subfeedHash, message, timeoutMsec } = reqData;
        await __classPrivateFieldGet(this, _node).feedManager().submitMessage({ feedId, subfeedHash, message, timeoutMsec });
        const response = { success: true };
        if (!core_1.isJSONObject(response))
            throw Error('Unexpected, not a JSON-serializable object');
        return response;
    }
    // /feed/getNumLocalMessages - get number of messages in a subfeed
    async _handleFeedApiGetNumLocalMessages(reqData) {
        /* istanbul ignore next */
        if (!exports.isFeedApiGetNumLocalMessagesRequest(reqData))
            throw Error('Invalid request in _feedApiGetNumLocalMessages');
        const { feedId, subfeedHash } = reqData;
        const numMessages = await __classPrivateFieldGet(this, _node).feedManager().getNumLocalMessages({
            feedId, subfeedHash
        });
        const response = { success: true, numMessages };
        if (!core_1.isJSONObject(response))
            throw Error('Unexpected, not a JSON-serializable object');
        return response;
    }
    // /feed/getFeedInfo - get info for a feed - such as whether it is writeable
    async _handleFeedApiGetFeedInfo(reqData) {
        /* istanbul ignore next */
        if (!exports.isFeedApiGetFeedInfoRequest(reqData))
            throw Error('Invalid request in _feedApiGetFeedInfo');
        const { feedId, timeoutMsec } = reqData;
        const liveFeedInfo = await __classPrivateFieldGet(this, _node).feedManager().getFeedInfo({ feedId, timeoutMsec });
        const response = { success: true, isWriteable: liveFeedInfo.nodeId === __classPrivateFieldGet(this, _node).nodeId(), nodeId: liveFeedInfo.nodeId };
        if (!core_1.isJSONObject(response))
            throw Error('Unexpected, not a JSON-serializable object');
        return response;
    }
    // /feed/getAccessRules - get access rules for a local writeable subfeed
    async _handleFeedApiGetAccessRules(reqData) {
        /* istanbul ignore next */
        if (!exports.isFeedApiGetAccessRulesRequest(reqData))
            throw Error('Invalid request in _feedApiGetAccessRules');
        const { feedId, subfeedHash } = reqData;
        const accessRules = await __classPrivateFieldGet(this, _node).feedManager().getAccessRules({ feedId, subfeedHash });
        let response;
        if (accessRules) {
            response = { success: true, accessRules };
        }
        else {
            response = { success: false, accessRules: null };
        }
        ;
        if (!core_1.isJSONObject(response))
            throw Error('Unexpected, not a JSON-serializable object');
        return response;
    }
    // /feed/setAccessRules - set access rules for a local writeable subfeed
    async _handleFeedApiSetAccessRules(reqData) {
        /* istanbul ignore next */
        if (!exports.isFeedApiSetAccessRulesRequest(reqData))
            throw Error('Invalid request in _feedApiSetAccessRules');
        const { feedId, subfeedHash, accessRules } = reqData;
        await __classPrivateFieldGet(this, _node).feedManager().setAccessRules({ feedId, subfeedHash, accessRules });
        const response = { success: true };
        if (!core_1.isJSONObject(response))
            throw Error('Unexpected, not a JSON-serializable object');
        return response;
    }
    // /feed/watchForNewMessages - wait until new messages have been appended to a list of watched subfeeds
    async _handleFeedApiWatchForNewMessages(reqData) {
        /* istanbul ignore next */
        if (!exports.isFeedApiWatchForNewMessagesRequest(reqData))
            throw Error('Invalid request in _feedApiWatchForNewMessages');
        const { subfeedWatches, waitMsec, maxNumMessages, signed } = reqData;
        const messages = await __classPrivateFieldGet(this, _node).feedManager().watchForNewMessages({
            subfeedWatches: core_1.toSubfeedWatchesRAM(subfeedWatches), waitMsec, maxNumMessages: maxNumMessages || core_1.messageCount(0), signed: signed || false
        });
        const response = { success: true, messages: core_1.mapToObject(messages) };
        if (!core_1.isJSONObject(response))
            throw Error('Unexpected, not a JSON-serializable object');
        return response;
    }
    // /mutable/set - set a mutable value
    async _handleMutableApiSet(reqData) {
        /* istanbul ignore next */
        console.warn(reqData);
        if (!exports.isMutableApiSetRequest(reqData))
            throw Error('Invalid request in _mutableApiSet');
        const { key, value } = reqData;
        await __classPrivateFieldGet(this, _node).mutableManager().set(key, value);
        const response = { success: true };
        if (!core_1.isJSONObject(response))
            throw Error('Unexpected, not a JSON-serializable object');
        return response;
    }
    // /mutable/get - get a mutable value
    async _handleMutableApiGet(reqData) {
        /* istanbul ignore next */
        if (!exports.isMutableApiGetRequest(reqData))
            throw Error('Invalid request in _mutableApiGet');
        const { key } = reqData;
        const rec = await __classPrivateFieldGet(this, _node).mutableManager().get(key);
        const response = { success: true, found: rec !== undefined, value: rec !== undefined ? rec.value : '' };
        if (!core_1.isJSONObject(response))
            throw Error('Unexpected, not a JSON-serializable object');
        return response;
    }
    // /mutable/delete - delete a mutable value
    async _handleMutableApiDelete(reqData) {
        /* istanbul ignore next */
        if (!exports.isMutableApiDeleteRequest(reqData))
            throw Error('Invalid request in _mutableApiDelete');
        const { key } = reqData;
        await __classPrivateFieldGet(this, _node).mutableManager().delete(key);
        const response = { success: true };
        if (!core_1.isJSONObject(response))
            throw Error('Unexpected, not a JSON-serializable object');
        return response;
    }
    // Helper function for returning http request with an error response
    /* istanbul ignore next */
    async _errorResponse(req, res, code, errorString) {
        console.info(`Daemon responding with error: ${code} ${errorString}`);
        try {
            res.status(code).send(errorString);
        }
        catch (err) {
            console.warn(`Problem sending error`, { error: err.message });
        }
        await util_1.sleepMsec(core_1.scaledDurationMsec(100));
        try {
            req.connection.destroy();
        }
        catch (err) {
            console.warn('Problem destroying connection', { error: err.message });
        }
    }
    // Start listening via http/https
    async listen(port) {
        __classPrivateFieldSet(this, _server, await __classPrivateFieldGet(this, _node).externalInterface().startHttpServer(__classPrivateFieldGet(this, _app), port));
    }
}
exports.default = DaemonApiServer;
_node = new WeakMap(), _app = new WeakMap(), _server = new WeakMap(), _simpleGetHandlers = new WeakMap(), _simplePostHandlers = new WeakMap();
const isLocalRequest = (req) => {
    return (req.socket.localAddress === req.socket.remoteAddress);
};
//# sourceMappingURL=DaemonApiServer.js.map