"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, privateMap, value) {
    if (!privateMap.has(receiver)) {
        throw new TypeError("attempted to set private field on non-instance");
    }
    privateMap.set(receiver, value);
    return value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, privateMap) {
    if (!privateMap.has(receiver)) {
        throw new TypeError("attempted to get private field on non-instance");
    }
    return privateMap.get(receiver);
};
var _node, _webSocketServer;
Object.defineProperty(exports, "__esModule", { value: true });
const action_1 = require("../common/action");
const util_1 = require("../common/util");
const core_1 = require("../interfaces/core");
const ProxyWebsocketConnection_1 = require("../proxyConnections/ProxyWebsocketConnection");
class PublicWebSocketServer {
    constructor(kNode, { verbose }) {
        _node.set(this, void 0);
        _webSocketServer.set(this, null);
        __classPrivateFieldSet(this, _node, kNode);
    }
    stop() {
        if (__classPrivateFieldGet(this, _webSocketServer)) {
            __classPrivateFieldGet(this, _webSocketServer).close();
        }
    }
    async startListening(port) {
        let usedDisconnectDefect = false;
        __classPrivateFieldSet(this, _webSocketServer, await __classPrivateFieldGet(this, _node).externalInterface().startWebSocketServer(port, __classPrivateFieldGet(this, _node).nodeId()));
        __classPrivateFieldGet(this, _webSocketServer).onConnection((ws) => {
            /////////////////////////////////////////////////////////////////////////
            action_1.action('newProxyConnectionToClient', { context: 'PublicWebSocketServer' }, async () => {
                const X = new ProxyWebsocketConnection_1.ProxyWebsocketConnection(__classPrivateFieldGet(this, _node), { connectionType: 'connectionToClient' });
                await X.initializeConnectionToClient(ws);
                __classPrivateFieldGet(this, _node).setProxyConnectionToClient(X.remoteNodeId(), X);
                // TEST DEFECT ////////////////////////////////////////////////
                if ((__classPrivateFieldGet(this, _node).getDefects().disconnectIncomingProxyConnectionOnce) && (!usedDisconnectDefect)) {
                    usedDisconnectDefect = true;
                    (async () => {
                        await util_1.sleepMsec(core_1.scaledDurationMsec(4000));
                        X.close();
                    })();
                }
                ///////////////////////////////////////////////////////////////
            }, null);
            /////////////////////////////////////////////////////////////////////////
        });
    }
}
_node = new WeakMap(), _webSocketServer = new WeakMap();
exports.default = PublicWebSocketServer;
//# sourceMappingURL=PublicWebSocketServer.js.map